twitter4j

## Class JSONObject

- java.lang.Object
- - twitter4j.JSONObject

    public class JSONObject
    extends Object

A modifiable set of name/value mappings. Names are unique, non-null strings. Values may be any mix of `JSONObjects`, `JSONArrays`, Strings, Booleans, Integers, Longs, Doubles or `NULL`. Values may not be `null`, `NaNs`, `infinities`, or of any type not listed here.

This class can coerce values to another type when requested.

- When the requested type is a boolean, strings will be coerced using a case-insensitive comparison to "true" and "false".
- When the requested type is a double, other `Number` types will be coerced using `doubleValue`. Strings that can be coerced using `Double.valueOf(String)` will be.
- When the requested type is an int, other `Number` types will be coerced using `intValue`. Strings that can be coerced using `Double.valueOf(String)` will be, and then cast to int.
- When the requested type is a long, other `Number` types will be coerced using `longValue`. Strings that can be coerced using `Double.valueOf(String)` will be, and then cast to long. This two-step conversion is lossy for very large values. For example, the string "9223372036854775806" yields the long 9223372036854775807.
- When the requested type is a String, other non-null values will be coerced using `String.valueOf(Object)`. Although null cannot be coerced, the sentinel value `NULL` is coerced to the string "null".

This class can look up both mandatory and optional values:

- Use `getType()` to retrieve a mandatory value. This fails with a `JSONException` if the requested name has no value or if the value cannot be coerced to the requested type.
- Use `optType()` to retrieve an optional value. This returns a system- or user-supplied default if the requested name has no value or if the value cannot be coerced to the requested type.

Warning: this class represents null in two incompatible ways: the standard Java `null` reference, and the sentinel value `NULL`. In particular, calling `put(name, null)` removes the named entry from the object but `put(name, JSONObject.NULL)` stores an entry whose value is `JSONObject.NULL`.

Instances of this class are not thread safe. Although this class is nonfinal, it was not designed for inheritance and should not be subclassed. In particular, self-use by overrideable methods is not specified. See Effective Java Item 17, "Design and Document or inheritance or else prohibit it" for further information.

### Field Summary

Fields
`static Object` `NULL` A sentinel value used to explicitly define a name with no value.

### Constructor Summary

Constructors
Constructor and Description
`JSONObject()` Creates a `JSONObject` with no name/value mappings.
`JSONObject(JSONObject copyFrom, String[] names)` Creates a new `JSONObject` by copying mappings for the listed names from the given object.
`JSONObject(JSONTokener readFrom)` Creates a new `JSONObject` with name/value mappings from the next object in the tokener.
`JSONObject(Map copyFrom)` Creates a new `JSONObject` by copying all name/value mappings from the given map.
`JSONObject(String json)` Creates a new `JSONObject` with name/value mappings from the JSON string.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`JSONObject` `accumulate(String name, Object value)` Appends `value` to the array already mapped to `name`.
`JSONObject` `append(String name, Object value)` Appends values to the array mapped to `name`.
`Object` `get(String name)` Returns the value mapped by `name`, or throws if no such mapping exists.
`boolean` `getBoolean(String name)` Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or throws otherwise.
`double` `getDouble(String name)` Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or throws otherwise.
`int` `getInt(String name)` Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or throws otherwise.
`JSONArray` `getJSONArray(String name)` Returns the value mapped by `name` if it exists and is a `JSONArray`, or throws otherwise.
`JSONObject` `getJSONObject(String name)` Returns the value mapped by `name` if it exists and is a `JSONObject`, or throws otherwise.
`long` `getLong(String name)` Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or throws otherwise.
`String` `getString(String name)` Returns the value mapped by `name` if it exists, coercing it if necessary, or throws if no such mapping exists.
`boolean` `has(String name)` Returns true if this object has a mapping for `name`.
`boolean` `isNull(String name)` Returns true if this object has no mapping for `name` or if it has a mapping whose value is `NULL`.
`Iterator<String>` `keys()` Returns an iterator of the `String` names in this object.
`Set<String>` `keySet()` Returns the set of `String` names in this object.
`int` `length()` Returns the number of name/value mappings in this object.
`JSONArray` `names()` Returns an array containing the string names in this object.
`static String` `numberToString(Number number)` Encodes the number as a JSON string.
`Object` `opt(String name)` Returns the value mapped by `name`, or null if no such mapping exists.
`boolean` `optBoolean(String name)` Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or false otherwise.
`boolean` `optBoolean(String name, boolean fallback)` Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or `fallback` otherwise.
`double` `optDouble(String name)` Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or `NaN` otherwise.
`double` `optDouble(String name, double fallback)` Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or `fallback` otherwise.
`int` `optInt(String name)` Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or 0 otherwise.
`int` `optInt(String name, int fallback)` Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or `fallback` otherwise.
`JSONArray` `optJSONArray(String name)` Returns the value mapped by `name` if it exists and is a `JSONArray`, or null otherwise.
`JSONObject` `optJSONObject(String name)` Returns the value mapped by `name` if it exists and is a `JSONObject`, or null otherwise.
`long` `optLong(String name)` Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or 0 otherwise.
`long` `optLong(String name, long fallback)` Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or `fallback` otherwise.
`String` `optString(String name)` Returns the value mapped by `name` if it exists, coercing it if necessary, or the empty string if no such mapping exists.
`String` `optString(String name, String fallback)` Returns the value mapped by `name` if it exists, coercing it if necessary, or `fallback` if no such mapping exists.
`JSONObject` `put(String name, boolean value)` Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
`JSONObject` `put(String name, double value)` Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
`JSONObject` `put(String name, int value)` Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
`JSONObject` `put(String name, long value)` Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
`JSONObject` `put(String name, Object value)` Maps `name` to `value`, clobbering any existing name/value mapping with the same name.
`JSONObject` `putOpt(String name, Object value)` Equivalent to `put(name, value)` when both parameters are non-null; does nothing otherwise.
`static String` `quote(String data)` Encodes `data` as a JSON string.
`Object` `remove(String name)` Removes the named mapping if it exists; does nothing otherwise.
`JSONArray` `toJSONArray(JSONArray names)` Returns an array with the values corresponding to `names`.
`String` `toString()` Encodes this object as a compact JSON string, such as:
`String` `toString(int indentSpaces)` Encodes this object as a human readable JSON string for debugging, such as:
`static Object` `wrap(Object o)` Wraps the given object if necessary.

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### NULL

    public static final Object NULL

A sentinel value used to explicitly define a name with no value. Unlike `null`, names with this value:

- show up in the `names()` array
- show up in the `keys()` iterator
- return `true` for `has(String)`
- do not throw on `get(String)`
- are included in the encoded JSON string.

This value violates the general contract of `Object.equals(java.lang.Object)` by returning true when compared to `null`. Its `toString()` method returns "null".

### Constructor Detail

#### JSONObject

    public JSONObject()

Creates a `JSONObject` with no name/value mappings.

#### JSONObject

    public JSONObject(Map copyFrom)

Creates a new `JSONObject` by copying all name/value mappings from the given map.

Parameters:
  `copyFrom` - a map whose keys are of type `String` and whose values are of supported types.
Throws:
  `NullPointerException` - if any of the map's keys are null.

#### JSONObject

    public JSONObject(JSONTokener readFrom)
               throws JSONException

Creates a new `JSONObject` with name/value mappings from the next object in the tokener.

Parameters:
  `readFrom` - a tokener whose nextValue() method will yield a `JSONObject`.
Throws:
  `JSONException` - if the parse fails or doesn't yield a `JSONObject`.

#### JSONObject

    public JSONObject(String json)
               throws JSONException

Creates a new `JSONObject` with name/value mappings from the JSON string.

Parameters:
  `json` - a JSON-encoded string containing an object.
Throws:
  `JSONException` - if the parse fails or doesn't yield a `JSONObject`.

#### JSONObject

    public JSONObject(JSONObject copyFrom,
                      String[] names)
               throws JSONException

Creates a new `JSONObject` by copying mappings for the listed names from the given object. Names that aren't present in `copyFrom` will be skipped.

Parameters:
  `copyFrom` - The source object.
  `names` - The names of the fields to copy.
Throws:
  `JSONException` - On internal errors. Shouldn't happen.

### Method Detail

#### length

    public int length()

Returns the number of name/value mappings in this object.

Returns:
  the length of this.

#### put

    public JSONObject put(String name,
                          boolean value)
                   throws JSONException

Maps `name` to `value`, clobbering any existing name/value mapping with the same name.

Parameters:
  `name` - The name of the value to insert.
  `value` - The value to insert.
Returns:
  this object.
Throws:
  `JSONException` - Should not be possible.

#### put

    public JSONObject put(String name,
                          double value)
                   throws JSONException

Maps `name` to `value`, clobbering any existing name/value mapping with the same name.

Parameters:
  `name` - The name for the new value.
  `value` - a finite value. May not be `NaNs` or `infinities`.
Returns:
  this object.
Throws:
  `JSONException` - if value is NaN or infinite.

#### put

    public JSONObject put(String name,
                          int value)
                   throws JSONException

Maps `name` to `value`, clobbering any existing name/value mapping with the same name.

Parameters:
  `name` - The name for the new value.
  `value` - The new value.
Returns:
  this object.
Throws:
  `JSONException` - Should not be possible.

#### put

    public JSONObject put(String name,
                          long value)
                   throws JSONException

Maps `name` to `value`, clobbering any existing name/value mapping with the same name.

Parameters:
  `name` - The name of the new value.
  `value` - The new value to insert.
Returns:
  this object.
Throws:
  `JSONException` - Should not be possible.

#### put

    public JSONObject put(String name,
                          Object value)
                   throws JSONException

Maps `name` to `value`, clobbering any existing name/value mapping with the same name. If the value is `null`, any existing mapping for `name` is removed.

Parameters:
  `name` - The name of the new value.
  `value` - a `JSONObject`, `JSONArray`, String, Boolean, Integer, Long, Double, `NULL`, or `null`. May not be `NaNs` or `infinities`.
Returns:
  this object.
Throws:
  `JSONException` - if the value is an invalid double (infinite or NaN).

#### putOpt

    public JSONObject putOpt(String name,
                             Object value)
                      throws JSONException

Equivalent to `put(name, value)` when both parameters are non-null; does nothing otherwise.

Parameters:
  `name` - The name of the value to insert.
  `value` - The value to insert.
Returns:
  this object.
Throws:
  `JSONException` - if the value is an invalid double (infinite or NaN).

#### accumulate

    public JSONObject accumulate(String name,
                                 Object value)
                          throws JSONException

Appends `value` to the array already mapped to `name`. If this object has no mapping for `name`, this inserts a new mapping. If the mapping exists but its value is not an array, the existing and new values are inserted in order into a new array which is itself mapped to `name`. In aggregate, this allows values to be added to a mapping one at a time. Note that `append(String, Object)` provides better semantics. In particular, the mapping for `name` will always be a `JSONArray`. Using `accumulate` will result in either a `JSONArray` or a mapping whose type is the type of `value` depending on the number of calls to it.

Parameters:
  `name` - The name of the field to change.
  `value` - a `JSONObject`, `JSONArray`, String, Boolean, Integer, Long, Double, `NULL` or null. May not be `NaNs` or `infinities`.
Returns:
  this object after mutation.
Throws:
  `JSONException` - If the object being added is an invalid number.

#### append

    public JSONObject append(String name,
                             Object value)
                      throws JSONException

Appends values to the array mapped to `name`. A new `JSONArray` mapping for `name` will be inserted if no mapping exists. If the existing mapping for `name` is not a `JSONArray`, a `JSONException` will be thrown.

Parameters:
  `name` - The name of the array to which the value should be appended.
  `value` - The value to append.
Returns:
  this object.
Throws:
  `JSONException` - if `name` is `null` or if the mapping for `name` is non-null and is not a `JSONArray`.

#### remove

    public Object remove(String name)

Removes the named mapping if it exists; does nothing otherwise.

Parameters:
  `name` - The name of the mapping to remove.
Returns:
  the value previously mapped by `name`, or null if there was no such mapping.

#### isNull

    public boolean isNull(String name)

Returns true if this object has no mapping for `name` or if it has a mapping whose value is `NULL`.

Parameters:
  `name` - The name of the value to check on.
Returns:
  true if the field doesn't exist or is null.

#### has

    public boolean has(String name)

Returns true if this object has a mapping for `name`. The mapping may be `NULL`.

Parameters:
  `name` - The name of the value to check on.
Returns:
  true if this object has a field named `name`

#### get

    public Object get(String name)
               throws JSONException

Returns the value mapped by `name`, or throws if no such mapping exists.

Parameters:
  `name` - The name of the value to get.
Returns:
  The value.
Throws:
  `JSONException` - if no such mapping exists.

#### opt

    public Object opt(String name)

Returns the value mapped by `name`, or null if no such mapping exists.

Parameters:
  `name` - The name of the value to get.
Returns:
  The value.

#### getBoolean

    public boolean getBoolean(String name)
                       throws JSONException

Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or throws otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value if it exists.
Throws:
  `JSONException` - if the mapping doesn't exist or cannot be coerced to a boolean.

#### optBoolean

    public boolean optBoolean(String name)

Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or false otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value if it exists.

#### optBoolean

    public boolean optBoolean(String name,
                              boolean fallback)

Returns the value mapped by `name` if it exists and is a boolean or can be coerced to a boolean, or `fallback` otherwise.

Parameters:
  `name` - The name of the field we want.
  `fallback` - The value to return if the field isn't there.
Returns:
  The selected value or the fallback.

#### getDouble

    public double getDouble(String name)
                     throws JSONException

Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or throws otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value if it exists.
Throws:
  `JSONException` - if the mapping doesn't exist or cannot be coerced to a double.

#### optDouble

    public double optDouble(String name)

Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or `NaN` otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value if it exists.

#### optDouble

    public double optDouble(String name,
                            double fallback)

Returns the value mapped by `name` if it exists and is a double or can be coerced to a double, or `fallback` otherwise.

Parameters:
  `name` - The name of the field we want.
  `fallback` - The value to return if the field isn't there.
Returns:
  The selected value or the fallback.

#### getInt

    public int getInt(String name)
               throws JSONException

Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or throws otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value if it exists.
Throws:
  `JSONException` - if the mapping doesn't exist or cannot be coerced to an int.

#### optInt

    public int optInt(String name)

Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or 0 otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value if it exists.

#### optInt

    public int optInt(String name,
                      int fallback)

Returns the value mapped by `name` if it exists and is an int or can be coerced to an int, or `fallback` otherwise.

Parameters:
  `name` - The name of the field we want.
  `fallback` - The value to return if the field isn't there.
Returns:
  The selected value or the fallback.

#### getLong

    public long getLong(String name)
                 throws JSONException

Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or throws otherwise. Note that JSON represents numbers as doubles, so this is lossy; use strings to transfer numbers via JSON without loss.

Parameters:
  `name` - The name of the field that we want.
Returns:
  The value of the field.
Throws:
  `JSONException` - if the mapping doesn't exist or cannot be coerced to a long.

#### optLong

    public long optLong(String name)

Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or 0 otherwise. Note that JSON represents numbers as doubles, so this is lossy; use strings to transfer numbers via JSON.

Parameters:
  `name` - The name of the field we want.
Returns:
  The selected value.

#### optLong

    public long optLong(String name,
                        long fallback)

Returns the value mapped by `name` if it exists and is a long or can be coerced to a long, or `fallback` otherwise. Note that JSON represents numbers as doubles, so this is lossy; use strings to transfer numbers via JSON.

Parameters:
  `name` - The name of the field we want.
  `fallback` - The value to return if the field isn't there.
Returns:
  The selected value or the fallback.

#### getString

    public String getString(String name)
                     throws JSONException

Returns the value mapped by `name` if it exists, coercing it if necessary, or throws if no such mapping exists.

Parameters:
  `name` - The name of the field we want.
Returns:
  The value of the field.
Throws:
  `JSONException` - if no such mapping exists.

#### optString

    public String optString(String name)

Returns the value mapped by `name` if it exists, coercing it if necessary, or the empty string if no such mapping exists.

Parameters:
  `name` - The name of the field we want.
Returns:
  The value of the field.

#### optString

    public String optString(String name,
                            String fallback)

Returns the value mapped by `name` if it exists, coercing it if necessary, or `fallback` if no such mapping exists.

Parameters:
  `name` - The name of the field that we want.
  `fallback` - The value to return if the field doesn't exist.
Returns:
  The value of the field or fallback.

#### getJSONArray

    public JSONArray getJSONArray(String name)
                           throws JSONException

Returns the value mapped by `name` if it exists and is a `JSONArray`, or throws otherwise.

Parameters:
  `name` - The field we want to get.
Returns:
  The value of the field (if it is a JSONArray.
Throws:
  `JSONException` - if the mapping doesn't exist or is not a `JSONArray`.

#### optJSONArray

    public JSONArray optJSONArray(String name)

Returns the value mapped by `name` if it exists and is a `JSONArray`, or null otherwise.

Parameters:
  `name` - The name of the field we want.
Returns:
  The value of the specified field (assuming it is a JSNOArray

#### getJSONObject

    public JSONObject getJSONObject(String name)
                             throws JSONException

Returns the value mapped by `name` if it exists and is a `JSONObject`, or throws otherwise.

Parameters:
  `name` - The name of the field that we want.
Returns:
  a specified field value (if it is a JSONObject)
Throws:
  `JSONException` - if the mapping doesn't exist or is not a `JSONObject`.

#### optJSONObject

    public JSONObject optJSONObject(String name)

Returns the value mapped by `name` if it exists and is a `JSONObject`, or null otherwise.

Parameters:
  `name` - The name of the value we want.
Returns:
  The specified value.

#### toJSONArray

    public JSONArray toJSONArray(JSONArray names)
                          throws JSONException

Returns an array with the values corresponding to `names`. The array contains null for names that aren't mapped. This method returns null if `names` is either null or empty.

Parameters:
  `names` - The names of the fields that we want the values for.
Returns:
  The selected values.
Throws:
  `JSONException` - On internal errors. Shouldn't happen.

#### keys

    public Iterator<String> keys()

Returns an iterator of the `String` names in this object. The returned iterator supports `remove`, which will remove the corresponding mapping from this object. If this object is modified after the iterator is returned, the iterator's behavior is undefined. The order of the keys is undefined.

Returns:
  an iterator over the keys.

#### keySet

    public Set<String> keySet()

Returns the set of `String` names in this object. The returned set is a view of the keys in this object. `Set.remove(Object)` will remove the corresponding mapping from this object and set iterator behaviour is undefined if this object is modified after it is returned. See `keys()`.

Returns:
  The names in this object.

#### names

    public JSONArray names()

Returns an array containing the string names in this object. This method returns null if this object contains no mappings.

Returns:
  the names.

#### toString

    public String toString()

Encodes this object as a compact JSON string, such as:

    {"query":"Pizza","locations":[94043,90210]}

Overrides:
  `toString` in class `Object`

#### toString

    public String toString(int indentSpaces)
                    throws JSONException

Encodes this object as a human readable JSON string for debugging, such as:

     {
         "query": "Pizza",
         "locations": [
             94043,
             90210
         ]
     }

Parameters:
  `indentSpaces` - the number of spaces to indent for each level of nesting.
Returns:
  The string containing the pretty form of this.
Throws:
  `JSONException` - On internal errors. Shouldn't happen.

#### numberToString

    public static String numberToString(Number number)
                                 throws JSONException

Encodes the number as a JSON string.

Parameters:
  `number` - a finite value. May not be `NaNs` or `infinities`.
Returns:
  The encoded number in string form.
Throws:
  `JSONException` - On internal errors. Shouldn't happen.

#### quote

    public static String quote(String data)

Encodes `data` as a JSON string. This applies quotes and any necessary character escaping.

Parameters:
  `data` - the string to encode. Null will be interpreted as an empty string.
Returns:
  the quoted string.

#### wrap

    public static Object wrap(Object o)

Wraps the given object if necessary.

If the object is null or , returns `NULL`. If the object is a `JSONArray` or `JSONObject`, no wrapping is necessary. If the object is `NULL`, no wrapping is necessary. If the object is an array or `Collection`, returns an equivalent `JSONArray`. If the object is a `Map`, returns an equivalent `JSONObject`. If the object is a primitive wrapper type or `String`, returns the object. Otherwise if the object is from a `java` package, returns the result of `toString`. If wrapping fails, returns null.

Parameters:
  `o` - The object to wrap.
Returns:
  The wrapped (if necessary) form of the object {$code o}